#!/bin/sh

CC="gcc -m32"
WHICH=$1
OPT=-O1
FLAGS=-DUSE_CPU_COUNTER

if test "$WHICH" = "" ; then
  echo "missing argument"
  echo "Valid arguments are:"
  echo "  0 - unoptimized combine1"
  echo "  1 - combine1 with -O1"
  echo "  2 - combine2 with -O1"
  echo "  3 - combine3 with -O1"
  echo "  4 - combine4 with -O1"
  echo "  5_2 - combine5 with x2 unroll, -O1"
  echo "  5_4 - combine5 with x4 unroll, -O1"
  echo "  6_2 - combine6 with x2 parallel, -O1"
  echo "  6_4 - combine6 with x4 parallel, -O1"
  echo "  6_8 - combine6 with x8 parallel, -O1"
  echo "  7 - combine7, -O1"
  exit 1
fi

if test "$WHICH" = "0" ; then
 WHICH=1
 OPT=-O0
fi

$CC $OPT $FLAGS -o combine -DINT -DPLUS -DCOMBINE$WHICH combine.c
ip=`./combine`

$CC $OPT $FLAGS -o combine -DINT -DTIMES -DCOMBINE$WHICH combine.c
im=`./combine`

$CC $OPT $FLAGS -o combine -DFLOAT -DPLUS -DCOMBINE$WHICH combine.c
fp=`./combine`

$CC $OPT $FLAGS -o combine -DFLOAT -DTIMES -DCOMBINE$WHICH combine.c
fm=`./combine`

$CC $OPT $FLAGS -o combine -DDOUBLE -DPLUS -DCOMBINE$WHICH combine.c
dp=`./combine`

$CC $OPT $FLAGS -o combine -DDOUBLE -DTIMES -DCOMBINE$WHICH combine.c
dm=`./combine`

echo "int+   int*   float+   double+   float*   double*"
echo "$ip   $im   $fp     $dp     $fm      $dm"

